<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Component</title>
</head>
<body>

<main>
    <users>Ejemplo de componentes</users>
</main>

<template id="users-template">
    <div>
        <section>
            <h2><slot></slot></h2>
            <input type="search" placeholder="Search user" v-model="search">
        </section>
        <hr>
        <section>
            <user-component v-for="user in filterUser" :data="user"></user-component>
        </section>
    </div>
</template>

<template id="user-template">
    <div>
        <img :src="data.photo" alt="" align="left">
        <section>
            <h4>{{ data.name }}</h4>
            <p>{{ data.email }}</p>
        </section>
    </div>
</template>

<script src="https://cdn.jsdelivr.net/npm/vue/dist/vue.js"></script>
<script src="https://unpkg.com/axios/dist/axios.min.js"></script>

<script>

    Vue.component('users', {
        template: '#users-template',
        mounted() {
            axios.get('https://randomuser.me/api/?results=50')
                .then((response) => {
                    this.users = response.data.results.map((user) => {
                        return {
                            name: `${user.name.first} ${user.name.last}`,
                            email: user.email,
                            photo: user.picture.thumbnail
                        }
                    })
                })
        },
        data() {
            return {
                users: [],
                search: ''
            }
        },
        computed: {
            filterUser() {
                return this.users.filter((user) => {
                    return user.name.includes(this.search)
                })
            }
        }
    });

    Vue.component('user-component', {
        props: ['data'],
        template: '#user-template',
    });

    new Vue({
        el: 'main'
    })
</script>

</body>
</html>